#!/usr/bin/env python
# -*- coding: utf-8 -*-

import unittest

from test_cases import eleccard_setUp

from test_cases import eleccard_check

# 添加保卡
def suites_addElecCard():
    suite = unittest.TestSuite()
    suite.addTest(eleccard_check.CheckElecCardBind('test_checkElecCard_unbind'))
    suite.addTest(eleccard_setUp.SetUpElecCard('test_addElecCard_success'))
    suite.addTest(eleccard_check.CheckElecCardBind('test_checkElecCard_customerMachine'))
    suite.addTest(eleccard_check.GetCardInfo('test_getCardInfo_success'))
    return suite

# 客机置为样机
def suites_setElecCardtoSample():
    suite = unittest.TestSuite()
    # 机器是客机状态
    suite.addTest(eleccard_check.CheckElecCardBind('test_checkElecCard_customerMachine'))
    # 置为样机
    suite.addTest(eleccard_setUp.SetToSample('test_updateToSample_success'))
    # 检验判断为客机
    suite.addTest(eleccard_check.CheckElecCardBind('test_checkElecCard_sampleMachine'))
    return suite

# 样机置为客机
def suites_setElecCardtoCustomer():
    suite = unittest.TestSuite()
    # 机器是样机状态
    suite.addTest(eleccard_check.CheckElecCardBind('test_checkElecCard_sampleMachine'))
    # 置为客机
    suite.addTest(eleccard_setUp.SetToCustomerMachine('test_updateToCustomer_success'))
    # 检查需要添加保卡
    suite.addTest(eleccard_check.CheckElecCardBind('test_checkElecCard_unbind'))

# 客机修改保卡


# 客机解绑保卡